import kv.schemas as schemas
import kv.crud as crud
from kv.database import get_db
from sqlalchemy.orm import Session
from fastapi import APIRouter, Depends
from typing import List
router = APIRouter()

"""get"""


@router.get("/get_money_types", response_model=List[schemas.MoneyTypesSerializer])
def get_money_types(db: Session = Depends(get_db)):
    data = crud.PaymentViewSet.get_money_types(db)
    return data


@router.get("/get_worker_types", response_model=List[schemas.WorkerTypesSerializer])
def get_worker_types(db: Session = Depends(get_db)):
    data = crud.PaymentViewSet.get_worker_types(db)
    return data


@router.get("/get_payer_category_types", response_model=List[schemas.PayerCategoryTypesSerializer])
def get_payer_category_types(db: Session = Depends(get_db)):
    data = crud.PaymentViewSet.get_payer_category_types(db)
    return data


@router.get("/get_services_additional", response_model=List[schemas.ServicesAdditionalSerializer])
def get_services_additional(db: Session = Depends(get_db)):
    data = crud.PaymentViewSet.get_services_additional(db)
    return data


"""post"""


@router.post('/get_receipt_calculate', response_model=List[schemas.ReceiptCalculatedSerializer])
def get_receipt_calculate(request: schemas.RecieptCalculateInit, db: Session = Depends(get_db)):
    return crud.PaymentViewSet.get_receipt_calculate(db, request)


@router.post('/save_receipt')
def save_receipt(request: schemas.ReceiptSaveInit, db: Session = Depends(get_db)):
    return crud.PaymentViewSet.save_receipt(db, request)


@router.post('/repayment_info', response_model=List[schemas.RentRepaymentInfoSerializer])
def repayment_info(request: schemas.RepaymentInfoInit, db: Session = Depends(get_db)):
    return crud.PaymentViewSet.repayment_info(db, request)


@router.post('/repayment', response_model=List[schemas.RentRepaymentSerializer])
def repayment(request: schemas.RepaymentInit, db: Session = Depends(get_db)):
    return crud.PaymentViewSet.repayment(db, request)
