import kv.schemas as schemas
import kv.crud as crud
from kv.database import get_db
from sqlalchemy.orm import Session
from fastapi import APIRouter, Depends
from typing import List
router = APIRouter()

"""post"""


@router.post('/get_report_filter_types', response_model=List[schemas.ReportFilterTypeSerializer])
def get_report_filter_types(request: schemas.UserInit, db: Session = Depends(get_db)):
    return crud.ReportFilterViewSet.get_report_filter_types(db, request)


@router.post('/get_report_filtered_list', response_model=List[schemas.ReportFilterListSerializer])
def get_report_filtered_list(request: schemas.ReportFilterInit, db: Session = Depends(get_db)):
    return crud.ReportFilterViewSet.get_report_filtered_list(db, request)


@router.post('/set_report_filter_list', response_model=List[schemas.ReportFilterListSerializer])
def set_report_filter_list(request: schemas.ReportFilterSetInit, db: Session = Depends(get_db)):
    return crud.ReportFilterViewSet.set_report_filter_list(db, request)
